-- An Addon by Doxshund

local active = false -- here we store if the addon is active


local frame=CreateFrame("FRAME"); -- Create a frame for tracking units buffs


-- Set default, if trackharmonycolor hasn't been set up yet
if trackharmonycolor==nil then
 trackharmonycolor = 'green'
end

frame:SetScript('OnEvent',function()  -- set a script for then the event occurs
  local found=0 -- here we store if we found Harmony
  for i=1,40 do -- loop through max 40 buffs
    local _,_,_,_,_,_,_,_,_,_,id=UnitAura("Player",i) -- we only need the last agrument of UnitAura, which is spellID
      if id==100977 then -- 100977 = Harmony
        if trackharmonycolor=='red' then SpellActivationOverlay_ShowOverlay(SpellActivationOverlayFrame,100977,"TEXTURES\\SPELLACTIVATIONOVERLAYS\\FURY_OF_STORMRAGE.BLP","TOP",1.2,225,25,25,false,false); -- show the green overlay
        end
        if trackharmonycolor=='blue' then SpellActivationOverlay_ShowOverlay(SpellActivationOverlayFrame,100977,"TEXTURES\\SPELLACTIVATIONOVERLAYS\\FURY_OF_STORMRAGE.BLP","TOP",1.2,1,30,200,false,false); -- show the red overlay
        end
        if trackharmonycolor=='purple' then SpellActivationOverlay_ShowOverlay(SpellActivationOverlayFrame,100977,"TEXTURES\\SPELLACTIVATIONOVERLAYS\\FURY_OF_STORMRAGE.BLP","TOP",1.2,220,1,220,false,false); -- show the red overlay
        end
        if trackharmonycolor=='green' then SpellActivationOverlay_ShowOverlay(SpellActivationOverlayFrame,100977,"TEXTURES\\SPELLACTIVATIONOVERLAYS\\FURY_OF_STORMRAGE.BLP","TOP",1,255,255,255,false,false); -- show the red overlay
        end
        found=1 -- we found the spell, store it
      end
    end 
    if found==0 then SpellActivationOverlay_HideOverlays(SpellActivationOverlayFrame,100977) -- if we didnt find the spell, remove the overlay.
  end 
end)


local playerClass, englishClass = UnitClass("player")
if englishClass == "DRUID" then -- if player is druid
  frame:RegisterEvent("UNIT_AURA") -- register when the buffs/debuffs of the player change
  active = true
end

SLASH_MyAddon1Commands1, SLASH_MyAddon2Commands1, SLASH_MyAddon3Commands1 = '/thcolor', '/th', '/thhelp';

local function slashHandler1(msg, editbox)
  msg = msg:lower() -- Convert to lowercase
  if msg == 'red'  then
    trackharmonycolor = 'red'
    print("Harmony Tracking Color now is RED!")    
  elseif msg== 'blue' then
    trackharmonycolor = 'blue'
    print("Harmony Tracking now BLUE!")
  elseif msg== 'purple' then
    trackharmonycolor = 'purple'
    print("Harmony Tracking now PURPLE!")
  else
    trackharmonycolor = 'green'
    print("Harmony Tracking Color now GREEN!")
 end 
end

local function slashHandler2(msg, editbox)
 msg = msg:lower() -- Convert to lowercase
 if msg == 'off'  then
  active = false
  print("Harmony Tracking now DISABLED!")
  frame:UnregisterEvent("UNIT_AURA") -- unregister buff/debuff changes
  SpellActivationOverlay_HideOverlays(SpellActivationOverlayFrame,100977) -- Hide the alert if active
 else
  active = true
  print("Harmony Tracking now ENABLED!")
  frame:RegisterEvent("UNIT_AURA")
 end 
end

local function slashHandler3(msg, editbox)
   print("/thcolor color (Red, Green, Blue, Purple)")
   print("/th on/off to toggle addon")
end

SlashCmdList["MyAddon1Commands"] = slashHandler1;
SlashCmdList["MyAddon2Commands"] = slashHandler2;
SlashCmdList["MyAddon3Commands"] = slashHandler3;
